#include "xstm32f4xx.h"

void  WaitMsec( int );


/********************
 *
 ********************/
int  dev_get_btn_stat( void )
{
    int  stat = 0 ;
    unsigned int  data ;

    data = GPIOC->IDR ;
    if( (data & (0x1 << 13)) == 0 ) {
        stat |= 0x01;
    }

    return( stat );
}


/********************
 *
 ********************/
int  dev_get_lmt1_stat( void )
{
    int  stat = 0 ;
    unsigned int  data ;

    data = GPIOB->IDR ;
    if( (data & (0x1 << 1)) != 0 ) {
        stat |= 0x01;
    }

    return( stat );
}


/********************
 *
 ********************/
int  dev_get_lmt2_stat( void )
{
    int  stat = 0 ;
    unsigned int  data ;

    data = GPIOB->IDR ;
    if( (data & (0x1 << 2)) != 0 ) {
        stat |= 0x01;
    }

    return( stat );
}


/********************
 *
 ********************/
void  dev_led_on( void )
{
  GPIOA->BSRR = (0x1 << 12);
}


/********************
 *
 ********************/
void  dev_led_off( void )
{
  GPIOA->BSRR = (0x1 << 12) << 16;
}


/********************
 *
 ********************/
void  dev_mdrv_mot1_cw( void )
{
  GPIOB->BSRR = (0x1 << 4);       /* I1:H */
  GPIOB->BSRR = (0x1 << 5) <<16;  /* I2:L */
}


/********************
 *
 ********************/
void  dev_mdrv_mot1_ccw( void )
{
  GPIOB->BSRR = (0x1 << 4) <<16;  /* I1:L */
  GPIOB->BSRR = (0x1 << 5);       /* I2:H */
}


/********************
 *
 ********************/
void  dev_mdrv_mot1_brake( void )
{
  GPIOB->BSRR = (0x1 << 4);       /* I1:H */
  GPIOB->BSRR = (0x1 << 5);       /* I2:H */
}


/********************
 *
 ********************/
void  dev_mdrv_mot1_stop( void )
{
  GPIOB->BSRR = (0x1 << 4) <<16;  /* I1:L */
  GPIOB->BSRR = (0x1 << 5) <<16;  /* I2:L */
}


/********************
 *
 ********************/
void  dev_mdrv_mot2_cw( void )
{
  GPIOB->BSRR = (0x1 << 14);       /* I3:H */
  GPIOB->BSRR = (0x1 << 15) <<16;  /* I4:L */
}


/********************
 *
 ********************/
void  dev_mdrv_mot2_ccw( void )
{
  GPIOB->BSRR = (0x1 << 14) <<16;  /* I3:L */
  GPIOB->BSRR = (0x1 << 15);       /* I4:H */
}


/********************
 *
 ********************/
void  dev_mdrv_mot2_brake( void )
{
  GPIOB->BSRR = (0x1 << 14);       /* I3:H */
  GPIOB->BSRR = (0x1 << 15);       /* I4:H */
}


/********************
 *
 ********************/
void  dev_mdrv_mot2_stop( void )
{
  GPIOB->BSRR = (0x1 << 14) <<16;  /* I3:L */
  GPIOB->BSRR = (0x1 << 15) <<16;  /* I4:L */
}


/********************
 *
 ********************/
void  dev_init( void )
{
  /* set clock enable */
  RCC->AHB1ENR |= ( RCC_AHB1ENR_GPIOAEN
                   |RCC_AHB1ENR_GPIOBEN
                   |RCC_AHB1ENR_GPIOCEN
                  ) ;

  /** for BTN:PC13 **/
  GPIOC->MODER   &= ~(0x3 << (13*2));
  GPIOC->MODER   |=  (0x0 << (13*2));
  GPIOC->OTYPER  &= ~(0x1 << 13);
  GPIOC->OTYPER  |=  (0x0 << 13);
  GPIOC->OSPEEDR &= ~(0x3 << (13*2));
  GPIOC->OSPEEDR |=  (0x1 << (13*2));
  GPIOC->PUPDR   &= ~(0x3 << (13*2));
  GPIOC->PUPDR   |=  (0x1 << (13*2));

  /** for LED:PA12 **/
  GPIOA->MODER   &= ~(0x3 << (12*2));
  GPIOA->MODER   |=  (0x1 << (12*2));
  GPIOA->OTYPER  &= ~(0x1 << 12);
  GPIOA->OTYPER  |=  (0x0 << 12);
  GPIOA->OSPEEDR &= ~(0x3 << (12*2));
  GPIOA->OSPEEDR |=  (0x1 << (12*2));
  GPIOA->PUPDR   &= ~(0x3 << (12*2));
  GPIOA->PUPDR   |=  (0x1 << (12*2));
  GPIOA->BSRR     =  (0x1 << 12) << 16;  /* L */

  /** for LMT1:PB1 **/
  GPIOB->MODER   &= ~(0x3 << (1*2));
  GPIOB->MODER   |=  (0x0 << (1*2));
  GPIOB->OTYPER  &= ~(0x1 << 1);
  GPIOB->OTYPER  |=  (0x0 << 1);
  GPIOB->OSPEEDR &= ~(0x3 << (1*2));
  GPIOB->OSPEEDR |=  (0x1 << (1*2));
  GPIOB->PUPDR   &= ~(0x3 << (1*2));
  GPIOB->PUPDR   |=  (0x1 << (1*2)); /* pull up */

  /** for LMT2:PB2 **/
  GPIOB->MODER   &= ~(0x3 << (2*2));
  GPIOB->MODER   |=  (0x0 << (2*2));
  GPIOB->OTYPER  &= ~(0x1 << 2);
  GPIOB->OTYPER  |=  (0x0 << 2);
  GPIOB->OSPEEDR &= ~(0x3 << (2*2));
  GPIOB->OSPEEDR |=  (0x1 << (2*2));
  GPIOB->PUPDR   &= ~(0x3 << (2*2));
  GPIOB->PUPDR   |=  (0x1 << (2*2)); /* pull up */

  GPIOB->MODER   &= ~(0x3 << (4*2));
  GPIOB->MODER   |=  (0x1 << (4*2));
  GPIOB->OTYPER  &= ~(0x1 << 4);
  GPIOB->OTYPER  |=  (0x1 << 4);
  GPIOB->OSPEEDR &= ~(0x3 << (4*2));
  GPIOB->OSPEEDR |=  (0x2 << (4*2));
  GPIOB->PUPDR   &= ~(0x3 << (4*2));
  GPIOB->PUPDR   |=  (0x1 << (4*2));
  GPIOB->BSRR     =  (0x1 << 4) << 16;  /* I1:L */

  /* MDRV-I2:PB5 */
  GPIOB->MODER   &= ~(0x3 << (5*2));
  GPIOB->MODER   |=  (0x1 << (5*2));
  GPIOB->OTYPER  &= ~(0x1 << 5);
  GPIOB->OTYPER  |=  (0x1 << 5);
  GPIOB->OSPEEDR &= ~(0x3 << (5*2));
  GPIOB->OSPEEDR |=  (0x2 << (5*2));
  GPIOB->PUPDR   &= ~(0x3 << (5*2));
  GPIOB->PUPDR   |=  (0x1 << (5*2));
  GPIOB->BSRR     =  (0x1 << 5) << 16;  /* I2:L */

  /* MDRV-I3:PB14 */
  GPIOB->MODER   &= ~(0x3 << (14*2));
  GPIOB->MODER   |=  (0x1 << (14*2));
  GPIOB->OTYPER  &= ~(0x1 << 14);
  GPIOB->OTYPER  |=  (0x1 << 14);
  GPIOB->OSPEEDR &= ~(0x3 << (14*2));
  GPIOB->OSPEEDR |=  (0x2 << (14*2));
  GPIOB->PUPDR   &= ~(0x3 << (14*2));
  GPIOB->PUPDR   |=  (0x1 << (14*2));
  GPIOB->BSRR     =  (0x1 << 14) << 16;  /* I3:L */

  /* MDRV-I4:PB15 */
  GPIOB->MODER   &= ~(0x3 << (15*2));
  GPIOB->MODER   |=  (0x1 << (15*2));
  GPIOB->OTYPER  &= ~(0x1 << 15);
  GPIOB->OTYPER  |=  (0x1 << 15);
  GPIOB->OSPEEDR &= ~(0x3 << (15*2));
  GPIOB->OSPEEDR |=  (0x2 << (15*2));
  GPIOB->PUPDR   &= ~(0x3 << (15*2));
  GPIOB->PUPDR   |=  (0x1 << (15*2));
  GPIOB->BSRR     =  (0x1 << 15) << 16;  /* I4:L */
}


/********************
 *
 ********************/
void  dev_tim_pwm_init32( void )
{
  TIM_TypeDef  *TIMx = TIM3;
  uint32_t  Channel = 0x00000004U;  /* Channel-2 */
  uint32_t  tmp;

  /* set clock enable */
  RCC->AHB1ENR |= ( 
                     RCC_AHB1ENR_GPIOCEN
                  ) ;

  RCC->APB1ENR |= ( 
                     RCC_APB1ENR_TIM3EN
                  ) ;

  WaitMsec(1);

  /* TIM3-CH2 : PC7 */
  GPIOC->MODER   &= ~(0x3 << (7*2));
  GPIOC->MODER   |=  (0x2 << (7*2));
  GPIOC->OTYPER  &= ~(0x1 << 7);
  GPIOC->OTYPER  |=  (0x0 << 7);
  GPIOC->OSPEEDR &= ~(0x3 << (7*2));
  GPIOC->OSPEEDR |=  (0x2 << (7*2));
  GPIOC->PUPDR   &= ~(0x3 << (7*2));
  GPIOC->PUPDR   |=  (0x2 << (7*2));

  GPIOC->AFR[0] &= ~(0xf0000000 ) ;
  GPIOC->AFR[0] |=  (0x20000000 ) ; /* set AF2 */

  WaitMsec(1);

  /* prescaler */
  TIMx->PSC = 84-1;
  /* auto-reload register */
  TIMx->ARR = 20000-1;

  tmp = TIM_CCER_CC1E << Channel;

  /* Reset the CCxE Bit */
  TIMx->CCER &= ~tmp;

  /* Set or reset the CCxE Bit */ 
  TIMx->CCER |= (uint32_t)(0x00000001U << Channel);

  TIMx->CCMR1 &= ~(0x7 << 12);
  TIMx->CCMR1 |=  (0x6 << 12);

  TIMx->BDTR |= TIM_BDTR_MOE;
  TIMx->CR1 |= TIM_CR1_CEN;

  TIMx->CNT = 1000-1;

  *(uint32_t *)(&(TIMx->CCR1) + (Channel >> 2U)) = 1000;
}


/********************
 *
 ********************/
void  dev_tim_pwm_set32( int val )
{
  TIM_TypeDef  *TIMx = TIM3;
  uint32_t  Channel = 0x00000004U;  /* Channel-2 */

  *(uint32_t *)(&(TIMx->CCR1) + (Channel >> 2U)) = val;
}


